#define ErroFilaVazia -1
#define ErroFilaCheia -2

typedef struct fila {
  int info;
  fila *prox;
} Fila;

//criao de uma fila vazia
Fila *criaFila()
{
return NULL;
}

/* insero na fila */
Fila *Emfila (Fila *p, int i)
{
Fila *aux=p;
Fila *novo = (Fila*) malloc(sizeof(Fila));
novo->info = i;
novo->prox = NULL;
if(aux!=NULL)
{
  while(aux->prox!=NULL)
  {
     aux = aux->prox;
  }
  aux->prox=novo;
}
else
{
    p=novo;
}
return p;
}

/* funo imprime: imprime valores dos elementos */
void imprimeFila (Fila *p)
{
Fila *aux;
printf("\nImpressao da fila: \n");
for (aux = p; aux != NULL; aux = aux->prox)
printf("info = %d\n", aux->info);
printf("======================= fim da fila");
}

/* funo vazia: retorna 1 se vazia ou 0 se no vazia */
int FilaVazia (Fila *p)
{
   return (p == NULL);
}

/* funo busca: busca um elemento na fila */
Fila *Busca (Fila *p, int v)
{ Fila *aux;
for (aux=p; aux!=NULL; aux = aux->prox)
{
   if (aux->info == v)
      return aux;
}
return NULL; /* no achou o elemento */
}

/* funo retira: retira elemento da fila */
Fila *Desemfila (Fila *p)
{
  Fila *aux=p;
  if (FilaVazia(p))
    printf("\nFila vazia");
  else
  {
     p=p->prox;
     free(aux);
     return p;
  }
}

void liberaFila (Fila *p)
{
Fila *l = p, *t;
while (l != NULL)
   {
      t = l->prox; /* guarda referncia p/ prx. elemento */
      free(l); /* libera a memria apontada por p */
      l = t; /* faz p apontar para o prximo */
   }
}

