#define ErroListaVazia -1
#define ErroListaCheia -2

typedef struct lista {
  int info;
  lista *prox;
} Lista;

//criao de uma lista vazia
Lista *criaLista()
{
return NULL;
}

/* insero no incio: retorna a lista atualizada */
Lista *insereLista (Lista *l, int i)
{
Lista *novo = (Lista*) malloc(sizeof(Lista));
novo->info = i;
novo->prox = l;
return novo;
}

/* funo imprime: imprime valores dos elementos */
void imprimeLista (Lista *l)
{
Lista *p;
printf("\nImpressao da lista: \n");
for (p = l; p != NULL; p = p->prox)
printf("info = %d\n", p->info);
printf("======================= fim da lista");
}

/* funo vazia: retorna 1 se vazia ou 0 se no vazia */
int ListaVazia (Lista *l)
{
   return (l == NULL);
}

/* funo busca: busca um elemento na lista */
Lista *Busca (Lista *l, int v)
{ Lista *p;
for (p=l; p!=NULL; p = p->prox)
{
   if (p->info == v)
      return p;
}
return NULL; /* no achou o elemento */
}

/* funo retira: retira elemento da lista */
Lista *Remove (Lista *l, int v)
{
  Lista *ant = NULL; /* ponteiro para elemento anterior */
  Lista *p = l; /* ponteiro para percorrer a lista */
  /* procura elemento na lista, guardando anterior */
  while (p != NULL && p->info != v)
  {
    ant = p;
    p = p->prox;
  }
  /* verifica se achou elemento */
  if (p == NULL)
  {
     printf("\nElemento nao encontrado\n");
     return l; /* no achou: retorna lista original */
  }
  /* retira elemento */
  if (ant == NULL)
  { /* retira elemento do inicio */
    l = p->prox;
    printf("\nElemento removido \n");
  }
  else
  {
    /* retira elemento do meio da lista */
    ant->prox = p->prox;
    printf("\nElemento removido \n");
  }
  free(p);
  return l;
}

void liberaLista (Lista *l)
{
Lista *p = l, *t;
while (p != NULL)
   {
      t = p->prox; /* guarda referncia p/ prx. elemento */
      free(p); /* libera a memria apontada por p */
      p = t; /* faz p apontar para o prximo */
   }
}


Lista *insere_ordenado (Lista *l, int v)
{
   Lista *novo;
   Lista *ant = NULL; /* ponteiro para elemento anterior */
   Lista *p = l; /* ponteiro para percorrer a lista */
   /* procura posio de insero */
   while (p != NULL && p->info < v)
   {
       ant = p;
       p = p->prox;
   }
   /* cria novo elemento */
   novo = (Lista*) malloc(sizeof(Lista));
   novo->info = v;
   /* encadeia elemento */
   if (ant == NULL)
   { /* se o anterior  vazio, insere elemento no incio */
      novo->prox = l; l = novo;
   }
   else
   { /* insere elemento no meio da lista */
      novo->prox = ant->prox;
      ant->prox = novo;
   }
   return l;
}
